// ignore_for_file: public_member_api_docs, non_constant_identifier_names

import 'package:copy_with_extension/copy_with_extension.dart';
import 'package:equatable/equatable.dart';
import 'package:healthrian_common_support/healthrian_common_support.dart';

part 'channels.g.dart';

@CopyWith()
class Channels extends Equatable {
  Channels({
    required List<double> l1,
    required List<double> l2,
    required List<double> l3,
    required List<double> aVR,
    required List<double> aVL,
    required List<double> aVF,
    required List<double> v1,
    required List<double> v2,
    required List<double> v3,
    required List<double> v4,
    required List<double> v5,
    required List<double> v6,
    this.dataFilter,
  }) : list = [l1, l2, l3, aVR, aVL, aVF, v1, v2, v3, v4, v5, v6];

  final List<List<double>> list;

  Channels.fromList(List<List<double>> list, [DataFilter? filter])
      : list = list,
        dataFilter = filter;

  final DataFilter? dataFilter;

  List<double> get l1 => list[0];

  /// specialized
  List<double> get l2 => list.length >= 2 ? list[1] : list[0];

  List<double> get l3 => list[2];

  List<double> get aVR => list[3];

  List<double> get aVL => list[4];

  List<double> get aVF => list[5];

  List<double> get v1 => list[6];

  List<double> get v2 => list[7];

  List<double> get v3 => list[8];

  List<double> get v4 => list[9];

  List<double> get v5 => list[10];

  List<double> get v6 => list[11];

  @deprecated
  List<List<double>> toList() => list;

  @override
  List<Object?> get props => [...list, dataFilter];

  Channels range(int start, [int? end]) {
    final res = list.map((e) {
      if (end != null && e.length < end) return <double>[];
      return e.sublist(start, end);
    }).toList();
    return Channels.fromList(res);
  }
}
