// ignore_for_file: public_member_api_docs, non_constant_identifier_names

import 'package:copy_with_extension/copy_with_extension.dart';
import 'package:equatable/equatable.dart';
import 'package:healthrian_common_support/healthrian_common_support.dart';

part 'plot_channels.g.dart';

@CopyWith()
class PlotChannels extends Equatable {
  PlotChannels({
    required List<FlSpot> l1,
    required List<FlSpot> l2,
    required List<FlSpot> l3,
    required List<FlSpot> aVR,
    required List<FlSpot> aVL,
    required List<FlSpot> aVF,
    required List<FlSpot> v1,
    required List<FlSpot> v2,
    required List<FlSpot> v3,
    required List<FlSpot> v4,
    required List<FlSpot> v5,
    required List<FlSpot> v6,
    this.pivot = 0,
    this.countRemoves = 9,
    this.countUpdates = 125,
  }) : list = [l1, l2, l3, aVR, aVL, aVF, v1, v2, v3, v4, v5, v6];

  final List<List<FlSpot>> list;

  PlotChannels.fromList(
    List<List<FlSpot>> list,
    this.pivot,
    this.countRemoves,
    this.countUpdates,
  ) : list = list;

  List<FlSpot> get l1 => list[0];

  /// specialized
  List<FlSpot> get l2 => list.length >= 2 ? list[1] : list[0];

  List<FlSpot> get l3 => list[2];

  List<FlSpot> get aVR => list[3];

  List<FlSpot> get aVL => list[4];

  List<FlSpot> get aVF => list[5];

  List<FlSpot> get v1 => list[6];

  List<FlSpot> get v2 => list[7];

  List<FlSpot> get v3 => list[8];

  List<FlSpot> get v4 => list[9];

  List<FlSpot> get v5 => list[10];

  List<FlSpot> get v6 => list[11];

  final int pivot;
  final int countUpdates;
  final int countRemoves;

  int get countSamples => l2.length;

  @deprecated
  List<List<FlSpot>> toList() => list;

  @override
  List<Object?> get props => [
        ...list,
        pivot,
        countUpdates,
        countRemoves,
      ];
}
