import 'package:healthrian_common_support/healthrian_common_support.dart';
import 'package:iirjdart/butterworth.dart';

class IIRFilter extends FilterInterface {
  final butterworth = new Butterworth();

  IIRFilter({
    required Enum filterType,
    bool is250Hz = true,
    // double cutoffFrequency = 0.0,
    // int directFormType = 0,
  }) {
    final samplingRate = is250Hz ? 250.0 : 500.0;
    if (filterType is LowPass) {
      butterworth.lowPass(1, samplingRate, 0, 0);
    } else if (filterType is HighPass) {
      butterworth.highPass(1, samplingRate, 0, 0);
    } else if (filterType is BandStop) {
      butterworth.bandStop(1, samplingRate, 0, 0);
    }
  }

  double apply(double input) {
    return butterworth.filter(input);
  }
}
