import 'package:healthrian_common_support/healthrian_common_support.dart';

extension BulkFilter on DataFilter {
  /// apply forward
  void applyForward(int channel, List<dynamic> inputs, List<bool>? leadStates) {
    for (var i = 0; i < inputs.length; i++) {
      inputs[i] = this.applyFilter(
          channel, inputs[i], leadStates?.elementAtOrNull(i) ?? true);
    }
  }

  void applyForwardBackward(
      int channel, List<dynamic> inputs, List<bool>? leadStates) {
    for (var i = 0; i < inputs.length; i++) {
      inputs[i] = this.applyFilter(
          channel, inputs[i], leadStates?.elementAtOrNull(i) ?? true);
    }

    for (var i = inputs.length - 1; i >= 0; i--) {
      inputs[i] = this.applyFilter(
          channel, inputs[i], leadStates?.elementAtOrNull(i) ?? true);
    }
  }
}
