import 'dart:convert';
import 'dart:io';

import 'package:flutter_test/flutter_test.dart';
import 'package:healthrian_common_support/healthrian_common_support.dart';
import 'package:healthrian_common_support/src/utility/bulk_filter.dart';

void main() {
  test('data_filter_fir', () {
    final dataFilter = DataFilter(1);
    dataFilter.bandStop = BandStop.off;
    dataFilter.highPass = HighPass.off;
    dataFilter.lowPass = LowPass.off;
    dataFilter.firBandStop = FirBandStop.bsf60;

    final input = File('test/input/60hz_noise.json');
    final inputAsString = input.readAsStringSync();
    final inputAsMap = jsonDecode(inputAsString);
    final l2 = inputAsMap['l2'] as List;

    final output = File('test/output/fir.txt');

    final buffer = StringBuffer();
    for (final d in l2) {
      buffer.write('${dataFilter.applyFilter(0, d, true)}\n');
    }
    output.writeAsStringSync(buffer.toString());
  });


  test('data_filter_fir_band_stop_stopwatch', () {
    final dataFilter = DataFilter(1);

    final input = File('test/input/60hz_noise.json');
    final inputAsString = input.readAsStringSync();
    final inputAsMap = jsonDecode(inputAsString);
    final l2 = inputAsMap['l2'] as List;

    final now = DateTime.now();
    // for (final d in l2) {
    //   dataFilter.applyFilter(0, d, true);
    // }
    dataFilter.applyForwardBackward(0, l2, null);
    print(DateTime.now().difference(now));
  });
}
